//! \file    ContextWindow.cpp
//! \brief   Implementation of the Context window for visual_YAO.
//! \version 2010/06/16 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: ContextWindow.cpp
  Nom de classe:
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/ContextWindow.hpp"
using namespace std;
using namespace yao;

//! \class ContextWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Context window for visual_YAO.
/******************************************************************************************************************************************************/
ContextWindow::ContextWindow(Context *aContext, Table <Constant> *aConstantTable, MainWindowController *mwc, QWidget *parent) : QWidget(parent), localConstantTable(NULL), m_contextModel(NULL), O_EXTOBJModele(NULL) {

	setupUi(this);

	localConstantTable 	 = aConstantTable;
	m_localContext		 = aContext;
	if (isContextListEmpty()) m_delButtonO_EXTOBJ->setDisabled(true);  
		m_comboContextO_REAL->insertItem(0, ""); 
		m_comboContextO_REAL->insertItem(1, "FLOAT"); 
		m_comboContextO_REAL->insertItem(2, "DOUBLE"); 
		m_comboContextO_MQN->insertItem(0, ""); 
		m_comboContextO_MQN->insertItem(1, "M1QN3"); 
		m_comboContextO_MQN->insertItem(2, "M2QN1"); 
		m_comboContextO_PARALLEL->insertItem(0, ""); 
		m_comboContextO_PARALLEL->insertItem(1, "ACTIF"); 
				
		m_comboContextO_NETWARD->insertItem(0, ""); 

		m_comboContextO_EXTOBJ->insertItem(0, ""); 

		m_comboContextO_PARALLEL->setEditable(true);

	for (Table<Constant>::reverse_iterator it = localConstantTable->rbegin(); it != localConstantTable->rend(); it++) 
		{
			m_comboContextO_PARALLEL->insertItem(2, QString(it->getName().c_str()));
			m_comboContextO_NETWARD->insertItem(1, QString(it->getName().c_str()));
			m_comboContextO_EXTOBJ->insertItem(1, QString(it->getName().c_str())); 
		}

	filesListModele = new QStringListModel(filesList);

	/*m_contextTableView->setModel(m_contextModel);
		  m_contextTableView->resizeColumnsToContents();
                  m_contextTableView->setEditTriggers(QAbstractItemView::NoEditTriggers); 
                  m_contextTableView->setShowGrid(false);  
                  m_contextTableView->setSelectionBehavior(QAbstractItemView::SelectRows); 
	*/
	/*for (Table<Constant>::reverse_iterator it = localConstantTable->rbegin(); it != localConstantTable->rend(); it++)  {
	
		m_contextModel->setItem(row, 0, new QStandardItem(m_comboContextO_REAL->currentText()));  
	} */	

	O_EXTOBJModele = new QStandardItemModel(0, 1) ; 	


	for (vector <string>::reverse_iterator it = m_fileList.rbegin(); it != m_fileList.rend(); it++ ) 
		{
			O_EXTOBJModele->appendRow(new QStandardItem(QString(it->c_str())));	
		}
	
	m_contextO_EXTOBJListView->setModel(O_EXTOBJModele); 

	//connect(m_enregContext, SIGNAL(clicked()), this, SLOT(saveContextData()));
        connect(m_contextSaveButton, SIGNAL(clicked()), this, SLOT(saveParameters()));
	connect(m_contextResetButton, SIGNAL(clicked()), this, SLOT(resetParameters()));
        connect(m_contextQuitButton, SIGNAL(clicked()), this, SLOT(close()));
	connect(m_contextHelpButton, SIGNAL(clicked()), this, SLOT(callContextHelp()));
	
        connect(m_addButtonO_EXTOBJ, SIGNAL(clicked()), this, SLOT(addO_EXTOBJRow()));
	connect(m_delButtonO_EXTOBJ, SIGNAL(clicked()), this, SLOT(deleteO_EXTOBJRow()));

	setFixedWidth(baseSize().width() + 560);

}
/**************************************** Implémentation de la méthode addContextRow *****************************************************************/
/*void ContextWindow::addContextRow() {

	try {
			//filesList.append(m_comboContextO_REAL->currentText());
			//filesListModele->setStringList(filesList);
			//testContenu(compteur);
		
			int row = m_contextModel->rowCount();
			m_contextModel->setItem(row, 0, new QStandardItem(m_comboContextO_REAL->currentText()));  
			m_contextModel->setItem(row, 1, new QStandardItem(m_comboContextO_MQN->currentText()));  
			m_contextModel->setItem(row, 2, new QStandardItem(m_comboContextO_PARALLEL->currentText()));  
			m_contextModel->setItem(row, 3, new QStandardItem(m_comboContextO_NETWARD->currentText()));  
		
			m_contextModel->setItem(row, 4, new QStandardItem(m_comboContextO_EXTOBJ->currentText()));  
			//if (m_checkBoxO_GRADTEST->isChecked())
			m_checkBoxO_GRADTEST->isChecked()?m_contextModel->setItem(row, 5, new QStandardItem("oui")):m_contextModel->setItem(row, 5, new QStandardItem("non"));
			m_checkBoxO_VARINCR->isChecked() ?m_contextModel->setItem(row, 6, new QStandardItem("oui")):m_contextModel->setItem(row, 6, new QStandardItem("non"));
			m_checkBoxO_DBG_NANF->isChecked()?m_contextModel->setItem(row, 7, new QStandardItem("oui")):m_contextModel->setItem(row, 7, new QStandardItem("non"));
			m_checkBoxO_DBG_TING->isChecked()?m_contextModel->setItem(row, 8, new QStandardItem("oui")):m_contextModel->setItem(row, 8, new QStandardItem("non"));  
			m_checkBoxO_DBG_BETA->isChecked()?m_contextModel->setItem(row, 9, new QStandardItem("oui")):m_contextModel->setItem(row, 9, new QStandardItem("non"));  
			m_checkBoxO_DBG_TRC_FWARD->isChecked()?m_contextModel->setItem(row, 10, new QStandardItem("oui")):m_contextModel->setItem(row, 10, new QStandardItem("non"));
			m_checkBoxO_DBG_TRC_BWARD->isChecked()?m_contextModel->setItem(row, 11, new QStandardItem("oui")):m_contextModel->setItem(row, 11, new QStandardItem("non"));
			m_checkBoxO_DBG_TRC_LWARD->isChecked()?m_contextModel->setItem(row, 12, new QStandardItem("oui")):m_contextModel->setItem(row, 12, new QStandardItem("non"));  
			m_checkBoxO_DBG_TRC_AWARD->isChecked()?m_contextModel->setItem(row, 13, new QStandardItem("oui")):m_contextModel->setItem(row, 13, new QStandardItem("non"));  

			eraseDataFromLineEdit();
			if (!isContextListEmpty()) m_contextResetButton->setEnabled(true);
	}

	catch(...)
		{
			QMessageBox::critical(this, "Erreur", "Erreur dans la methode addContextRow()");
		}
} */

/**************************************** Implémentation de la méthode saveParameters() **************************************************************/
void ContextWindow::saveParameters() {

	try 
		{
			/*	m_contextModel->setItem(row, 0, new QStandardItem());  
		
			m_checkBoxO_GRADTEST->isChecked()
			m_checkBoxO_VARINCR->isChecked()
			m_checkBoxO_DBG_NANF->isChecked()
			m_checkBoxO_DBG_TING->isChecked()
			m_checkBoxO_DBG_BETA->isChecked()
			m_checkBoxO_DBG_TRC_FWARD->isChecked()
			m_checkBoxO_DBG_TRC_BWARD->isChecked()
			m_checkBoxO_DBG_TRC_LWARD->isChecked()
			m_checkBoxO_DBG_TRC_AWARD->isChecked()*/
			m_contextParametersToString.clear();
			string option = "option ";
			string o_real 		= m_comboContextO_REAL->currentText().toStdString(),
				o_mqn 		= m_comboContextO_MQN->currentText().toStdString(),
				o_parallel	= m_comboContextO_PARALLEL->currentText().toStdString(),
				o_netward	= m_comboContextO_NETWARD->currentText().toStdString(),	
				o_real2, o_mqn2, o_parallel2	;	
			
			if (!o_real.empty())
				//QMessageBox::critical(this, "Erreur", "");
				if ((o_real == "FLOAT") || (o_real == "DOUBLE")) 
					o_real2 = option + o_real;		
				
			if (!o_mqn.empty())
				if ((o_mqn == "M1QN3") || (o_mqn == "M2QN1"))
					o_mqn2 = option + o_mqn;
	
			if (!o_parallel.empty())
				if ((o_parallel == "ACTIF")) 
					o_parallel2 = option + "o_parallel" ;

			
			for (vector <string>::reverse_iterator it = m_fileList.rbegin(); it != m_fileList.rend(); it++ )
				{
					//string test.insert("");
					string test = "option ";
					m_contextParametersToString.append(test.append(it->c_str()));// << endl;
					m_contextParametersToString.append("\n");

					//cout << "coucou" << endl;
				}
			m_contextParametersToString = o_real2 + "\n" + o_mqn2 + "\n" + o_parallel2 + "\n";

			cout << "voici les parametres: " << endl << m_contextParametersToString << endl; 
		}
		catch(...) 
			{
				QMessageBox::critical(this, "Erreur", "Erreur dans la methode saveParameters()");
			}
}
              
/**************************************** Implémentation de la méthode saveParameters() **************************************************************/
void ContextWindow::addO_EXTOBJRow() {

	try 
		{
			O_EXTOBJModele->appendRow(new QStandardItem(m_comboContextO_EXTOBJ->currentText())); 
			m_fileList.push_back(m_comboContextO_EXTOBJ->currentText().toStdString());	
			m_comboContextO_EXTOBJ->setCurrentIndex(0);
		}
		catch(...) 
			{
				QMessageBox::critical(this, "Erreur", "Erreur dans la methode addO_EXTOBJRow()");
			}
}

/**************************************** Implémentation de la méthode deleteO_EXTOBJRow() **********************************************************/
void ContextWindow::deleteO_EXTOBJRow() {

	QItemSelectionModel *selection = m_contextO_EXTOBJListView->selectionModel(); 
	O_EXTOBJIndex = selection->currentIndex(); 

	if (!O_EXTOBJIndex.isValid()) 
		return; 

	QVariant element = O_EXTOBJModele->data(O_EXTOBJIndex, Qt::DisplayRole);
	int r = O_EXTOBJIndex.row();

	if (selection->hasSelection()) 
		{
			O_EXTOBJModele->removeRows(m_contextO_EXTOBJListView->currentIndex().row(), 1); 
			//localHeaderList->erase(localHeaderList->begin() + r);
			//if(isHeaderListEmpty()) m_delHatButton->setDisabled(true);
		}
	//cout << "Salut" << endl;
}

/*************************************** Implémentation de la méthode resetParameters ****************************************************************/
void ContextWindow::resetParameters() {

/*	QItemSelectionModel *selection = m_contextTableView->selectionModel();
	QModelIndex indexElementSelectionne = selection->currentIndex();
    	QVariant elementSelectionne = filesListModele->data(indexElementSelectionne, Qt::DisplayRole);

     	filesList.removeOne(elementSelectionne.toString());//Retrait de l'élément sélectionné de l'objet QStringList
     	filesListModele->setStringList(filesList); //On indique au modèle la liste des éléments à afficher.

*/
	eraseDataFromLineEdit();	
}

/*****************************************************************************************************************************/
void ContextWindow::saveContextData() {
	
}

/********************************************************************/
bool ContextWindow:: isContextListEmpty() {

	//int row = O_EXTOBJModele->rowCount();
	//if (row == 0)
	//	return true;
	//else 
		return false;
}


/*****************************************************************************************************************************/
/*****************************************************************************************************************************/
/****************************************************************************************************************************/
QStringList ContextWindow::getContextData() {

	return filesList;
}

/****************************************************************************************************************************/

/************************************* Implémentation de la méthode eraseDataFromLineEdit() ***********************************************************/
void ContextWindow::eraseDataFromLineEdit() {

	m_comboContextO_REAL->setCurrentIndex(0); 
	m_comboContextO_MQN->setCurrentIndex(0); 
	m_comboContextO_PARALLEL->setCurrentIndex(0);
	m_comboContextO_NETWARD->setCurrentIndex(0); 
	m_comboContextO_EXTOBJ->setCurrentIndex(0);
	m_checkBoxO_GRADTEST->setChecked(false);	
	m_checkBoxO_VARINCR->setChecked(false);
	m_checkBoxO_DBG_NANF->setChecked(false);
	m_checkBoxO_DBG_TING->setChecked(false);
	m_checkBoxO_DBG_BETA->setChecked(false);
	m_checkBoxO_DBG_TRC_FWARD->setChecked(false);
	m_checkBoxO_DBG_TRC_BWARD->setChecked(false);
	m_checkBoxO_DBG_TRC_LWARD->setChecked(false);
	m_checkBoxO_DBG_TRC_AWARD->setChecked(false);
		
}
/****************************************************************************************************************************/
void ContextWindow::callContextHelp() {

	QMessageBox::about(this, tr("Aide sur la directive Context."),("<p> Permet d’indiquer les options de génération de code à appliquer, le but étant de limiter ponctuellement la taille du code généré. <p><u>Exemple:</u> option o_m1qn3 <p> Pour plus d'informations sur la directive Context, <a href=\"help/option_aide.html\">cliquez ici.</a>"));

}

/****************************************** Implement of the method closeEvent(QCloseEvent *event) ****************************/
void ContextWindow::closeEvent(QCloseEvent *event){
 
     /* if (!(m_comboHatName->currentText().isEmpty()) && !(m_comboHatName->currentText().isEmpty())) {                                                  
          int ret = QMessageBox::warning(this, tr("Confirmation de fermeture"), tr("Voulez-vous vraiment quitter?"),                                      
                         QMessageBox::Yes | QMessageBox::Default, QMessageBox::Cancel | QMessageBox::Escape);                                            
                                                                           
          if (ret == QMessageBox::Yes) 
                 event->accept(); //cout << " test qui marche!" << endl;
          //         event->accept();
                 else
                   event->ignore();
          }*/
                 
           //        event->accept();
          //       emit contextWindowIsClosed(3);
	//	for (vector <string>::iterator it = m_fileList.begin(); it != m_fileList.end(); it++ )
            //                     {
                                         //string test.insert("");
                                         //string test = "opera ";
              //                           cout << it->c_str() << endl;
                //                         //cout << "coucou" << endl;
                  //               }

 } 
/******************************************************************************************************************************************************/
/********************************************** End of the Context.cpp file ***************************************************************************/
/******************************************************************************************************************************************************/
