/*
  Nom du Fichier: ContextWindow.hpp
  Nom de classe: ContextWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#ifndef ContextWINDOW_HPP
#define ContextWINDOW_HPP

#include <QStandardItemModel> 
#include "../../ui_contextwindow.h"
#include "MainWindowController.hpp"
#include <QString>
#include <QMessageBox>
//#include <QItemSelectionModel> 
#include <QModelIndex> 
#include <QFileDialog>
#include <QStringListModel>
#include <iostream>
#include <vector>
#include "../../../YAOObjects/Context.hpp"
#include "../../../YAOObjects/Constant.hpp"
#include "../../../YAOObjects/Table.hpp"

class ContextWindow : public QWidget, public Ui::ContextWindow {

    Q_OBJECT

	public :
            	ContextWindow(yao::Context *aContext, yao::Table <yao::Constant> *aConstantTable, MainWindowController *mwc, QWidget *parent=0);
		QStringList getContextData();
		void eraseDataFromLineEdit(); 

	private slots:

            	//void enregistrerContext();
            	//void ouvrirProjetExistant3();
            	void saveContextData();
	//	void addContextRow();
		void saveParameters();
		void addO_EXTOBJRow();
		void deleteO_EXTOBJRow();
		void resetParameters();
	        void callContextHelp();		
		bool isContextListEmpty();

	protected :
		void closeEvent(QCloseEvent *event);

	signals :
  
                  void contextWindowIsClosed(int anInt);


	private :

            	QFileDialog *projetContext;
		QString m_cheminProjetContext;
		
		QStringList filesList;	
		QStringListModel *filesListModele;

		QStandardItemModel *m_contextModel;
		QStandardItemModel *O_EXTOBJModele;
                QModelIndex index;
                QModelIndex O_EXTOBJIndex;

		//QStringListModel *model;
		//QStringList list;

		yao::Context *m_localContext;
		std::vector <std::string> m_fileList;
		std::string m_contextParametersToString;
		yao::Table <yao::Constant> *localConstantTable;
		MainWindowController *localMwc;
		int compteur;
		
};
#endif // ContextWINDOW_HPP
